package data;

import java.util.Random;

import miner.util.ArrayUtil;

public class RankingGeneratorPlackettLuce {
	
	private Random rand = new Random(System.currentTimeMillis());
	
	private double[] v;
	
	public RankingGeneratorPlackettLuce(double[] v)
	{
		this.v = v;
	}
	
	public int[][] genRankings(int n)
	{
		int l = v.length;
		int[][] rankings = new int[n][l];
		
		double[] help_rv = new double[l];
		double ir;
		double sm;

		for(int k=0; k < n; k++)
		{   
			for(int i=0; i < l; i++)
			{
				help_rv[i] = v[i];
			}
		    
		   for(int i=0; i < l; i++)
		   {
		        ir = rand.nextDouble() * ArrayUtil.sum(help_rv);		  
		        sm = 0;

		        for(int j=0; j < l; j++)
		        {
		            sm = sm + help_rv[j];

		            if(ir <= sm)
		            {
		               rankings[k][j] = i+1;
		               help_rv[j] = 0;
		               break;
		        	}
		        }
		    }
		}
		
		return rankings;
	}
	
	public static double[] thrustonScoresToPLv(double[] mu, double beta)
	{
		double[] out = new double[mu.length];

		for(int i=0; i < mu.length; i++)
		{
		    out[i] = Math.exp(mu[i]/beta);
		}
		
		return out;
	}

}
