package miner.pgminer;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map.Entry;
import java.util.Scanner;

import miner.RankingMiner;
import miner.util.DataMasterD2;
import miner.util.ObjectTuple;
import miner.util.PreferenceNode;
import miner.util.TransactionList;
import util.MemoryMonitor;
import util.PrintUtil;

/**
 * currently prefered Miner
 * @author client
 *
 */
public class PGDMinerWR2 implements RankingMiner{

	public DataMasterD2 dMaster;
	
	private ArrayList<ArrayList<ObjectTuple>> frqP_LL;
	
	private int 						absoluteT;
//	private int[][] 					iMatrix;
	private int[][][] 					iMatrix 		= null;
//	private ArrayList<int[]> 			leftPairs;
	private ArrayList<int[]> 			removeL;
	private TransactionList[] 			intersection_A 	= null;
	private ArrayList<PreferenceNode> 	hClosure 		= null;
	
	private PreferenceNode[] 			postClosures_A 	= null;
	private ArrayList<ArrayList<int[]>> leftPairs_L 	= null;
	private boolean[]					longerFound 	= null;
	
	
//	MemoryMonitor memMon;
	
	private int visitedNodes = 0; // test
	private Scanner keyboard = new Scanner(System.in);
		
	//#########################################################################
	// Constructor
	//#########################################################################
	
	public PGDMinerWR2(int[][] rankings)
	{
		int n = rankings[0].length;
		
		this.dMaster 		= new DataMasterD2(rankings);		
		this.iMatrix 		= new int[n][][];	
		this.intersection_A = new TransactionList[n];
		this.postClosures_A = new PreferenceNode[n];
		
		initInterList(rankings.length);
		initIMatrix(rankings[0].length);
		initVariables(rankings[0].length);
//		initPostClosureArray();
	}
	
	public PGDMinerWR2(ArrayList<int[]> rankings)
	{
		int n = rankings.get(0).length;
		
		this.dMaster 		= new DataMasterD2(rankings);
		this.iMatrix 		= new int[n][][];
		this.intersection_A = new TransactionList[n];
		this.postClosures_A = new PreferenceNode[n];
		
		initInterList(rankings.size());
		initIMatrix(rankings.get(0).length);
		initVariables(rankings.get(0).length);
//		initPostClosureArray();
	}
	
	private void initInterList(int size)
	{
		for(int i=0; i<intersection_A.length; i++)
		{
			intersection_A[i] = new TransactionList(size);
		}
	}
	
	private void initIMatrix(int size)
	{
		for(int i=0; i<iMatrix.length; i++)
		{
			iMatrix[i] = new int[size][size];
		}
	}
	
	private void initVariables(int size)
	{
		leftPairs_L = new ArrayList<>();
		for(int i=0; i<size; i++)
		{
			leftPairs_L.add(new ArrayList<int[]>());
		}
		
		longerFound = new boolean[size];
	}
	
//	private void initPostClosureArray()
//	{
//		for(int i=0; i<postClosures_A.length; i++)
//			postClosures_A[i] = new PreferenceNode(-1);
//	}
	
	//#########################################################################
	// Override RankingMiner
	//#########################################################################
	
	@Override
	public void mine(double t) {
		
		//##### MM #########
//		System.runFinalization();
//		memMon = new MemoryMonitor();
//		memMon.setStartMemory();

		//##################
		
		dMaster.compFrq2Tuple(t);		
		absoluteT 	= (int)Math.ceil((t * dMaster.size()));		
		frqP_LL 	= new ArrayList<ArrayList<ObjectTuple>>();
		removeL 	= new ArrayList<int[]>();
//		leftPairs 	= new ArrayList<int[]>();
		ArrayList<int[]> lPairs 	= new ArrayList<int[]>();

		//Generate one layer for every object
		for(int i=0; i<dMaster.numRanks(); i++)
		{
			frqP_LL.add(new ArrayList<ObjectTuple>());
		}
		
		ObjectTuple 	ot 			= null;
//		PreferenceNode 	postClosure = null;
		
		for(Entry<Integer, HashMap<Integer,TransactionList>> e: dMaster.getFrequentTuple().entrySet())
		{
			for(Entry<Integer,TransactionList> ep: e.getValue().entrySet())
			{
				lPairs.add(new int[]{e.getKey(),ep.getKey()});
			}
		}
		
		hClosure = new ArrayList<PreferenceNode>();
		
//memMon.updateMemory();
//System.out.println("currMem: " + memMon.getMemory());
//System.out.println("bevore tlcount: " + TransactionList.instanceCount);
		for(Entry<Integer, HashMap<Integer,TransactionList>> e: dMaster.getFrequentTuple().entrySet())
		{
			for(Entry<Integer,TransactionList> ep: e.getValue().entrySet())
			{

				ot = new ObjectTuple();
				ot.add(e.getKey());
				ot.add(ep.getKey());				
							
				for(int i=0; i<iMatrix.length; i++)
				for(int j=0; j<iMatrix.length; j++)
					iMatrix[0][i][j] = 0;
				
				removeL.clear();
				hClosure.clear();
				dMaster.compHClosure2(ep.getValue(), hClosure,iMatrix[0], lPairs, removeL, 0);
//System.out.println("oLoop tlcount: " + TransactionList.instanceCount);
				postClosures_A[0] = dMaster.isPrefixX2_2(hClosure, ot);

				
				if(postClosures_A[0] != null)
				{
//					leftPairs = new ArrayList<int[]>();
//					leftPairs.addAll(lPairs);
//					leftPairs.removeAll(removeL);
					
					leftPairs_L.get(0).clear();
					leftPairs_L.get(0).addAll(lPairs);
					leftPairs_L.get(0).removeAll(removeL);
					
					frqP_LL.get(0).add(ot);
					//########MM#######
//					memMon.gc();
//					memMon.updateMemory();					
//System.out.println("currMem: " + memMon.getUsedMemory());
//keyboard.next();

					//#################
					depthFirst(ot,ep.getValue(),iMatrix[0], leftPairs_L.get(0), 0);
//System.out.println("visited Nodes: " + visitedNodes);
visitedNodes = 0;
				}
			}
		}
		int count = 1;
		for(int i= frqP_LL.size(); i> 0; i--)
		{
			if(frqP_LL.get(i-1).size() == 0)
				frqP_LL.remove(frqP_LL.size()-count);
			else count++;
		}		
	}
	
	public void depthFirst(ObjectTuple ot, TransactionList tl, int[][] iMP, ArrayList<int[]> lpairs, int k)
	{
		visitedNodes++;
		longerFound[k] = false;

		if(dMaster.getFrequentTuple().containsKey(ot.getLast()))
		{	
			for(Entry<Integer,TransactionList> ep: dMaster.getFrequentTuple().get(ot.getLast()).entrySet())
			{				
				intersection_A[k].assimilate(ep.getValue());
				TransactionList.AND(intersection_A[k],tl);				
				
				// check for frequency
				if(intersection_A[k].count() >= absoluteT)
				{
					ObjectTuple otf = new ObjectTuple(ot);
					otf.add(ep.getKey());
						
					//Prefix Test
					if(intersection_A[k].equals(tl))
					{
						postClosures_A[k+1] = dMaster.recursivePrefSearchX2(postClosures_A[k], otf, ot.size());
					
						if(postClosures_A[k+1] != null)
						{	
							frqP_LL.get(k+1).add(otf);
							longerFound[k] = true;
							//copyMatrix
							for(int j=0; j<iMP.length; j++)
							{
								System.arraycopy(iMP[j],0,iMatrix[k+1][j],0,iMP.length);
							}
							//########MM#######
//							memMon.gc();
//							memMon.updateMemory();
//System.out.println("1: " + " vN: " + visitedNodes + " mem: " + memMon.getMemory());
//keyboard.next();
							//#################
							depthFirst(otf,intersection_A[k], iMatrix[k+1], lpairs, k+1);
						}				
					}
					else
					{
						hClosure.clear();
						//copy iMatrix
//						iMatrix = new int[iMP.length][iMP[0].length];
						for(int j=0; j<iMP.length; j++)
						{
							System.arraycopy(iMP[j],0,iMatrix[k+1][j],0,iMP.length);
						}
//memMon.updateMemory();
//System.out.println("2: " + " vN: " + visitedNodes + " mem: " + memMon.getMemory());
//keyboard.next();						
						removeL.clear();
						dMaster.compHClosure2(intersection_A[k], hClosure, iMatrix[k+1], lpairs, removeL, k+1);
						postClosures_A[k+1] = dMaster.isPrefixX2_2(hClosure, otf);
//memMon.updateMemory();
//System.out.println("3: " + " vN: " + visitedNodes + " mem: " + memMon.getMemory());
//keyboard.next();						
						if(postClosures_A[k+1] != null)
						{
//							leftPairs = new ArrayList<int[]>();
//							leftPairs.addAll(lpairs);
//							leftPairs.removeAll(removeL);
							
							leftPairs_L.get(k+1).clear();
							leftPairs_L.get(k+1).addAll(lpairs);
							leftPairs_L.get(k+1).removeAll(removeL);
							
							frqP_LL.get(k+1).add(otf);
							//########MM#######
//memMon.updateMemory();
//System.out.println("4: " + " vN: " + visitedNodes + " mem: " + memMon.getMemory());
//keyboard.next();	
//							memMon.gc();
//							memMon.updateMemory();
							//#################
							depthFirst(otf, intersection_A[k], iMatrix[k+1],leftPairs_L.get(k+1), k+1);
						}					
					}
				}
			}
		}

		if(longerFound[k])
		{
			frqP_LL.get(k).remove(frqP_LL.get(k).size()-1);
		}
	}
	
//	public long getUsedMemory()
//	{
//		return memMon.getUsedMemory();
//	}
	

	@Override
	public ArrayList<ArrayList<ObjectTuple>> getFrequent() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ArrayList<ArrayList<ObjectTuple>> getClosed() {

		return this.frqP_LL;
	}

	@Override
	public ArrayList<ArrayList<ObjectTuple>> getMaximal() {
		// TODO Auto-generated method stub
		return null;
	} //Prefix Generator Miner

	@Override
	public int getID() {
		return 204;
	}

}