package miner.util;

import java.util.ArrayList;
import java.util.TreeSet;

public class FrequencyChecker {
	
	public TreeSet<OTFWrapper> compFrequency(ArrayList<ObjectTuple> subr, ArrayList<int[]> rankings)
	{
		int[][] data = new int[rankings.size()][];
		rankings.toArray(data);
		
		return compFrequency(subr, data);
	}
	
	public TreeSet<OTFWrapper> compFrequency(ArrayList<ObjectTuple> subr, int[][] rankings)
	{	
		TreeSet<OTFWrapper> ret_L = new TreeSet<>();
		
		for(ObjectTuple ot: subr)
		{		
			ret_L.add(new OTFWrapper(ot,getFrequency(ot,rankings)));
		}
		
		return ret_L;
	}
	
	public double getFrequency(ObjectTuple ot, ArrayList<int[]> rankings)
	{
		int[][] data = new int[rankings.size()][];
		rankings.toArray(data);
		
		return getFrequency(ot, data);
	}
	
	public double getFrequency(ObjectTuple ot, int[][] rankings)
	{
		int count = 0;
		for(int[] iA: rankings)
		{
			if(ot.isContainedInRanking(iA)) count++;
		}
		
//		return count/(double)rankings.length;
		return count;
	}

}
