package miner.util;

import java.util.ArrayList;
import java.util.TreeSet;

import util.PrintUtil;
import util.ArrayUtil;

public class ObjectTuple implements Comparable<ObjectTuple>{
	
//	private TransactionList tl = null;
//	private ArrayList<PreferenceNode> hClosure = null;
	private ArrayList<Integer> tuple_L = new ArrayList<>();
	
	private int absFrq;
	
	//experiemtel
//	private PreferenceNode postClosure = null;
	
	//#########################################################################
	// Constructor
	//#########################################################################
	
	public ObjectTuple(int[] ranking)
	{
		int[] help = new int[ranking.length];
		
		for(int i=0; i<help.length; i++)
		{
			if(ranking[i] > 0)
			{
				help[ranking[i]-1] = i+1;
			}
		}
		
		for(int i=0; i<help.length; i++)
		{
			if(help[i] > 0) tuple_L.add(help[i]);
		}
		
	}
	
	public ObjectTuple(int object)
	{	
		tuple_L.add(object);
	}
	
	public ObjectTuple(ObjectTuple ot)
	{
//		this.tl = ot.tl;
		for(Integer i: ot.tuple_L)
		{
			this.tuple_L.add(i);
		}
	}
	
	public ObjectTuple(){};
	
	//#########################################################################
	// Business Methods
	//#########################################################################
	
	public int size()
	{
		return tuple_L.size();
	}
	
	public int get(int index)
	{
		return tuple_L.get(index);
	}
	
	public ObjectTuple getPretuple(int end)
	{
		ObjectTuple ot = new ObjectTuple();
		
		ArrayList<Integer> t_list = new ArrayList<>();
		
		for(int i=0; i<=end; i++)
		{
			t_list.add(tuple_L.get(i));
		}
		
		ot.tuple_L = t_list;
		
		return ot;
	}
	
	public void add(int object)
	{
		tuple_L.add(object);
	}
	
	public TreeSet<ObjectTuple> getSubTuple()
	{
		TreeSet<ObjectTuple> ot_A = new TreeSet<>();
		
		for(int i=0; i<this.size(); i++)
		{
			ObjectTuple ot = new ObjectTuple();
					
			for(int j=0; j<this.size(); j++)
			{
				if(i != j) ot.add(tuple_L.get(j));
			}			
			ot_A.add(ot);
		}
		
		return ot_A;
	}
	
	public TreeSet<ObjectTuple> getPairTuple()
	{
		TreeSet<ObjectTuple> ot_A = new TreeSet<>();
		
		ObjectTuple ot;
		for(int i=0; i<this.size()-1; i++)
			for(int j=i+1; j<this.size(); j++)
			{
				ot = new ObjectTuple();
				ot.add(tuple_L.get(i));
				ot.add(tuple_L.get(j));
				ot_A.add(ot);
			}
		
		return ot_A;
	}
	
	public ArrayList<Integer> unionObjects(ObjectTuple ot)
	{
		return ArrayUtil.union(this.tuple_L, ot.tuple_L);
	}
	
	public ArrayList<Integer> intersectObjects(ObjectTuple ot)
	{
		return ArrayUtil.intersection(this.tuple_L, ot.tuple_L);
	}
	
	public boolean equals(ObjectTuple ot)
	{
		for(int i=0; i<size(); i++)
		{
			if(tuple_L.get(i) != ot.tuple_L.get(i)) return false;
		}
		
		return true;
	}
	
	public boolean isContainedInRanking(int[] ranking)
	{
		int r = 0;
		
		for(int i=0; i<this.size(); i++)
		{
			if(ranking[this.get(i)-1] <= r) return false;
			
			r = ranking[this.get(i)-1];
		}
		return true;
	}
	
	public boolean contains(ObjectTuple ot)
	{
		int k=0;
		
		if(this.size() < ot.size())
		{
			return false;
		}
		
		for(int i=0; i<this.size(); i++)
		{
			if(this.get(i) == ot.get(k)) k++;
			
			if(k == ot.size()) return true;
		}
		return false;
	}
	
	public int[] getRanking(int rSize)
	{
		int[] ranking = new int[rSize];
		
		for(int i=0; i<tuple_L.size(); i++)
		{
			ranking[tuple_L.get(i)-1] = i+1;
		}
		
		return ranking;
	}
	
	public int[] getOrdering()
	{
		int[] ordering = new int[tuple_L.size()];
		
		for(int i=0; i<tuple_L.size(); i++)
			ordering[i] = tuple_L.get(i);
		
		return ordering;
	}
	
	public int getAbsFrq()
	{
		return this.absFrq;
	}
	
	public void setAbsFrq(int absFrq)
	{
		this.absFrq = absFrq;
	}
	
	public boolean isConcordant(ObjectTuple ot)
	{
		int t = 0;
		int k = 0;
		for(int i=0; i<this.size(); i++)
		{
			for(int j=0; j<ot.size(); j++)
			{
				if(this.get(i) == ot.get(j))
				{
					if(k > 0) return false;
					if(j < t) return false;
					t = j;
					k++;
				}
			}
		}		
		return true;
	}
	
//	public void addRanking(int[] ranking)
//	{
//		int[] help = new int[ranking.length];
//		
//		for(int i=0; i<help.length; i++)
//		{
//			if(ranking[i] > 0)
//			{
//				help[ranking[i]-1] = i+1;
//			}
//		}
//		
//		for(int i=0; i<help.length; i++)
//		{
//			if(help[i] > 0) tuple_L.add(help[i]);
//		}
//	}
	
	public void clear()
	{
		this.tuple_L.clear();
		this.absFrq = 0;
	}
	
	//#########################################################################
	// static Methods
	//#########################################################################
	
	public static ObjectTuple rankingToObjectTuple(int[] ranking)
	{
		ObjectTuple tuple = new ObjectTuple();
		
		int[] help = new int[ranking.length];
		
		for(int i=0; i<help.length; i++)
		{
			if(ranking[i] > 0)
			{
				help[ranking[i]-1] = i+1;
			}
		}
		
		for(int i=0; i<help.length; i++)
		{
			if(help[i] > 0) tuple.add(help[i]);
		}
		
		return tuple;
	}
	
	//#########################################################################
	// Override Methods
	//#########################################################################
	
	@Override
	public int hashCode()
	{
		return 0;
	}
	
	@Override
	public String toString()
	{
		StringBuilder sb = new StringBuilder();
		
		sb.append("(");
		for(Integer i: tuple_L)
		{
			sb.append(i + ",");
		}
		sb.append(")");
		sb.append("{" + this.absFrq + "}");
		
		return sb.toString();
	}
	
	//#########################################################################
	// Override Comparable
	//#########################################################################
	
	@Override
	public int compareTo(ObjectTuple arg0) {
		
		for(int i=0; i<tuple_L.size(); i++)
		{
		try{	
			if(this.tuple_L.get(i) > arg0.tuple_L.get(i))
			{
				return 1;
			}
			else if(this.tuple_L.get(i) < arg0.tuple_L.get(i))
			{
				return -1;
			}
		}catch(ArrayIndexOutOfBoundsException e)
		{
			System.out.println(PrintUtil.printArray((Double[])this.tuple_L.toArray(), true) + " " + PrintUtil.printArray((Double[])arg0.tuple_L.toArray(),true));
			System.exit(0);
		}
		}
		
		return 0;
	}
	
//	public void intersectList(TransactionList tl)
//	{
//		this.tl = this.tl.AND(tl);
//	}
//	
//	public void setTransactionList(TransactionList tl)
//	{
//		this.tl = tl;
//	}
//	
//	public TransactionList getTransactionList()
//	{
//		return this.tl;
//	}
	
	public int getLast()
	{
		return this.tuple_L.get(tuple_L.size()-1);
	}
	
//	public void setHClosure(ArrayList<PreferenceNode> hClosure)
//	{
//		this.hClosure = hClosure;
//	}
//	
//	public ArrayList<PreferenceNode> getHClosure()
//	{
//		return this.hClosure;
//	}
	
	// EXPERIMENTEL###############################################################################
	
//	public void setPostClosure(PreferenceNode postClosure)
//	{
//		this.postClosure = postClosure;
//	}
//	
//	public PreferenceNode getPostClosure()
//	{
//		return this.postClosure;
//	}
	

}
