package miner.util;

import java.util.ArrayList;

public class PreferenceNode {
	
	private ArrayList<PreferenceNode> children_L = new ArrayList<>();
	
	private int value;
	private boolean flag = false;
	
	//#########################################################################
	// Constructor
	//#########################################################################
	
	public PreferenceNode(int value)
	{
		this.value = value;
	}
	
	//#########################################################################
	// Business Methods
	//#########################################################################
	
	public void addNode(PreferenceNode node)
	{
		children_L.add(node);
	}
	
	public PreferenceNode getNode(int index)
	{
		return children_L.get(index);
	}
	
	public int numChildren()
	{
		return children_L.size();
	}
	
	public void setFlag(boolean flag)
	{
		this.flag = flag;
	}
	
	public boolean getFlag()
	{
		return this.flag;
	}
	
	public int getValue()
	{
		return this.value;
	}
	
	public String toString()
	{
		StringBuilder sb = new StringBuilder();
		
		if(children_L.size() > 0)
		{
			sb.append(value + "-[");
			for(PreferenceNode ifn: children_L)
			{
				sb.append(ifn.toString());
			}
			sb.append("]");
		}
		else sb.append(value+",");
		
		return sb.toString();
	}
	
	public void clearUp(int i)
	{
		this.children_L.clear();
		this.value = i;
	}
	
	public void clear()
	{
		this.children_L.clear();
		this.value = -1;
	}
	
}
